using CloudBuilder.Core.Authorization;
using CloudBuilder.Core.DatabaseAccessor.Entity;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
namespace CloudBuilder.Security.Entity
 {
    [TypeScript]
    [Table("security_actor_group_view")]
    public class SecurityActorGroupViewEntity : ViewEntityBase
    {

    public SecurityActorGroupViewEntity() 
    {
    }

    [Column("actor_name")]
    public string ActorName  { get; set; }
    [Column("actor_local_name")]
    public string? ActorLocalName  { get; set; }
    [Column("group_name")]
    public string GroupName  { get; set; }
    [Column("group_local_name")]
    public string? GroupLocalName  { get; set; }

    public const string ACTOR_NAME = "ActorName";
    public const string ACTOR_LOCAL_NAME = "ActorLocalName";
    public const string GROUP_NAME = "GroupName";
    public const string GROUP_LOCAL_NAME = "GroupLocalName";

    public const string DB_NAME_SECURITY_ACTOR_GROUP_VIEW = "security_actor_group_view";
    public const string DB_NAME_FIELDS="actor_name,actor_local_name,group_name,group_local_name";

    public const string DB_ACTOR_NAME = "actor_name";
    public const string DB_ACTOR_LOCAL_NAME = "actor_local_name";
    public const string DB_GROUP_NAME = "group_name";
    public const string DB_GROUP_LOCAL_NAME = "group_local_name";


    public static SecurityActorGroupViewEntity GetInstance()
    {
        return new SecurityActorGroupViewEntity();
    }

    public virtual void CopyFrom(SecurityActorGroupViewEntity source)
    {
        CopyFrom(source, true);
    }

    public virtual void CopyFrom(SecurityActorGroupViewEntity source, bool includeSystemFields)
    {
        if (source == null)
        {
            throw new NullReferenceException("Source entity is null.");
        }

        this.ActorName =  source.ActorName;
        this.ActorLocalName =  source.ActorLocalName;
        this.GroupName =  source.GroupName;
        this.GroupLocalName =  source.GroupLocalName;

        if (includeSystemFields)
        {
        }
    }

    public override string GetSelectFrom()
    {
        return $" select {DB_NAME_FIELDS} from { DB_NAME_SECURITY_ACTOR_GROUP_VIEW}  with(nolock) ";
    }
	
    public override string GetSelectCountFrom(string sqlWhere)
    {
        return $" select count(*) from { DB_NAME_SECURITY_ACTOR_GROUP_VIEW}  with(nolock) where 1=1 {sqlWhere}";
    }
	
    public override string GetSelectTopFrom(int limit, int start,string orderby,string orderbytag,  string sqlWhere)
    {
            if (string.IsNullOrEmpty(orderbytag)  || orderbytag.Trim() != "desc") orderbytag = "asc";
		
        if (string.IsNullOrEmpty(orderby) || !DB_NAME_FIELDS.Contains(orderby)) orderby =  DB_ACTOR_NAME ;  		string top = limit > 0 ? $"top {limit}" : "";
        return $" select {top} {DB_NAME_FIELDS} from (select {DB_NAME_FIELDS}  ,row_number() over(order by {orderby} {orderbytag}) as num from { DB_NAME_SECURITY_ACTOR_GROUP_VIEW}  with(nolock) where 1=1 {sqlWhere} ) a where num> {limit * (start - 1)}";
    }

    public SecurityActorGroupViewEntity Clone()
    {
        SecurityActorGroupViewEntity result = new SecurityActorGroupViewEntity();
        result.CopyFrom(this);

        return result;
    }

    }
}
